if (typeof __opera__preload === 'undefined') {
var __opera__preload = {
    opera_console: console,
    opera_log: console.log,
    historyPush: history.pushState,
    documentIsReady: !1,
    realAddEventListener: HTMLDivElement.prototype.addEventListener,
    realRemoveEventListener: HTMLDivElement.prototype.removeEventListener,
    needsResume: !1,
    hasPaused: !1,
    debug: !1,
    log: function(a) {
        this.debug && this.opera_log.call(this.opera_console, a)
    },
    forceStopAutoPlayAudio: function() {
        var a = document.getElementsByTagName("audio");
        if (a) for (var b = 0; b < a.length; b++) {
            var c = a[b];
            c && c.autoplay && (c.pause(), this.needsResume = c.__opera__pausedByOpera = !0)
        }
    },
    stopAudio: function() {
        var a = document.getElementsByTagName("audio");
        if (a) for (var b = 0; b < a.length; b++) {
            var c = a[b];
            c && (!c.paused && c.played || c.buffered) && (c.pause(), this.needsResume = c.__opera__pausedByOpera = !0)
        }
    },
    resumeAudio: function() {
        if (this.needsResume) {
            var a = document.getElementsByTagName("audio");
            if (a) for (var b = 0; b < a.length; b++) {
                var c = a[b];
                c && c.paused && "__opera__pausedByOpera" in c && c.play()
            }
        }
    },
    onPageLoadedInBackground: function() {
        this.hasPaused || (this.hasPaused = !0, this.forceStopAutoPlayAudio())
    },
    onPagePaused: function() {
        this.hasPaused || (this.hasPaused = !0, this.stopAudio())
    },
    onPageResumed: function() {
        this.hasPaused && (this.hasPaused = !1, this.resumeAudio())
    },
    preloadLinkScoreMap: {
        "\u4e0b\u4e00\u9801": 110,
        "\u4e0b\u4e00\u9875": 110,
        "\u4e0b\u4e00\u9875>": 110,
        "\u4e0b\u4e00\u9875>>": 110,
        "\u4e0b\u4e00\u9875 (\u5feb\u6377\u952e\u2192)": 110,
        "\u770b\u4e0b\u4e00\u9875": 110,
        "\u4e0b\u9875": 110,
        "\u4e0b\u9801": 110,
        "\u7ffb\u4e0b\u9875": 110,
        "\u7ffb\u4e0b\u9801": 110,
        ">>\u4e0b\u9875": 110,
        "\u4e0b\u4e00\u5f20 >": 109,
        "\u4e0b\u4e00\u5e45 >": 109,
        next: 109,
        "next page": 109,
        "next\u00bb": 109,
        "next>>": 109,
        "next >>": 109,
        "next=>": 109,
        "next =>": 109,
        "next==>": 109,
        "next ==>": 109,
        "\u524d\u8fdb": 108,
        "\u7ffb\u9875": 108,
        "\u4e0b\u7bc7": 108,
        "\u540e\u9875": 108,
        "\u540e\u9875>": 108,
        "\u5f80\u540e>>": 108,
        "\u4e0b\u4e00\u4e2a": 108,
        "\u4e0b\u4e00\u5f20": 108,
        "\u4e0b\u4e00\u5e45": 108,
        "\u4e0b\u4e00\u7ae0": 108,
        "\u4e0b\u4e00\u8282": 108,
        "\u4e0b\u4e00\u7bc0": 108,
        "\u4e0b\u4e00\u7bc7": 108,
        "\u4e0b\u4e00\u6b65": 108,
        "\u4e0b\u4e00\u6761": 107,
        "\u4e0b\u7ae0": 106,
        "\u4e0b\u8282": 106,
        "\u540e\u4e00\u9875": 101,
        more: 100,
        "more...": 100,
        "more ...": 100,
        "->": 100,
        "- >": 100,
        "--\x3e": 100,
        "-- >": 100,
        "=>": 100,
        "==>": 100,
        "== >": 100,
        "&gt;&gt;": 100,
        "&gt; &gt;": 100,
        ">>": 100,
        "\u00bb": 100,
        "> >": 100,
        "> > >": 100
    },
    useLessChars: /[\s\n\r\t\"\'\d\[\]\u300b\u300a\u3010\u3011\u2192]+/,
    getTextScore: function(a) {
        return a ? (a = this.preloadLinkScoreMap[a]) ? a: 0 : 0
    },
    preprocessText: function(a) {
        for (var b = a.split(/\s/), c = "", e = b.length, g = 0; g < e; g++) {
            var f = b[g];
            if (f) {
                var f = f.replace(this.useLessChars, ""),
                d = this.getTextScore(f);
                if (100 < d) {
                    this.log("after split find text=" + f + " score=" + d);
                    c = f;
                    break
                }
            }
        }
        return c ? c: a
    },
    getCleanedText: function(a) {
        if (!a._targetText) return "";
        var b = a._targetText.toLowerCase(),
        b = this.preprocessText(b);
        b || ((b = this.getImageText(a)) && (b = this.preprocessText(b)), this.log("find text in alt of img:" + b));
        return b
    },
    getImageText: function(a) {
        if (!a) return null;
        a = a.getElementsByTagName("img");
        for (var b = null,
        c = 0; c < a.length; c++) var e = a[c].alt.toLowerCase(),
        b = 0 < this.getTextScore(e) ? e: b;
        return b
    },
    lowScoreHitCounter: {},
    countLowScoreHit: function(a, b) {
        100 < b || (this.lowScoreHitCounter[a] = a in this.lowScoreHitCounter ? this.lowScoreHitCounter[a] + 1 : 1)
    },
    shouldIgnore: function(a) {
        return a in this.lowScoreHitCounter && 2 < this.lowScoreHitCounter[a]
    },
    isGoodALink: function(a) {
        return ! a || "href" in a && "href" in location && a.href == location.href || 10 < a._targetText.length && "children" in a && 0 == a.children.length ? !1 : !0
    },
    getAbsolutePath: function(a, b) {
        if (!a || !b) return null;
        var c = a.split("/"),
        e = b.split("/");
        c.pop();
        for (var g = e.length,
        f = 0; f < g; f++) {
            var d = e[f];
            "." != d && (".." == d ? c.pop() : c.push(d))
        }
        return c.join("/")
    },
    MAX_LINK_LIMIT: 400,
    findPreloadLink: function() {
        if ("undefined" !== typeof OperaCallback && this.documentIsReady) {
            var a = null,
            b = 0,
            c = null;
            this.lowScoreHitCounter = {};
            var e = document.links;
            this.log("a links num=" + e.length);
            if (e.length > this.MAX_LINK_LIMIT) this.log("there is too much links give up finding next page.");
            else {
                try {
                    for (var g = e.length,
                    f = 0; f < g; f++) {
                        var d = e[f],
                        h = null; ! ("href" in d) && "baseURI" in d && d.baseURI && (h = this.getAbsolutePath(d.baseURI, d.getAttribute("href")));
                        h || (h = d.href);
                        if (0 != h.indexOf("javascript:") && -1 == h.indexOf("#") && (d._targetText = "innerText" in d ? d.innerText: null, d._targetText || (d._targetText = d.textContent), this.isGoodALink(d))) {
                            var k = this.getCleanedText(d);
                            if (k) {
                                var l = this.getTextScore(k);
                                this.countLowScoreHit(k, l);
                                l > b && (b = l, a = h, c = k, this.log("find one:text=" + k + " url=" + a))
                            }
                        }
                    }
                    this.shouldIgnore(c) && (a = null)
                } catch(m) {
                    this.log("exception err=" + m.stack)
                }
                a && OperaCallback.preload(a, location.href)
            }
        }
    },
    init: function() {
        this.log("__opera__preload call init...");
        var a = 5,
        b = function() {
            clearInterval(c);
            "undefined" != typeof OperaCallback && ("complete" === document.readyState ? (__opera__preload.documentIsReady = !0, setTimeout(function() {
                __opera__preload.findPreloadLink()
            },
            50 > document.links.length ? 100 : 1500)) : (3E3 > a && (a *= 2), __opera__preload.log("__opera__preload interval." + a), c = setInterval(b, a)))
        },
        c = setInterval(b, a)
    },
    caseByCase: function(a) {
        return "map.baidu.com" === location.hostname && "map-holder" === a.id || "tieba.baidu.com" === location.hostname && ("j_smile_container" === a.id || "j_font_container" === a.id) || "wap.sogou.com" === location.hostname && "imgBox" === a.className
    },
    draggableElements: [],
    excludeHostname: ["bbs.browser.qq.com"],
    isDraggable: function(a) {

			if(window.screen.width < document.body.clientWidth){
				return !0;
			}
        if ( - 1 != this.draggableElements.indexOf(a)) return this.log("could draggable: imply touchListener." + a.tagName),
        !0;
        for (; a && a != document.body;) {
            if (this.caseByCase(a)) return __opera__preload.log("could draggable: caseByCasy id=" + a.id),
            !0;
            if ( - 1 != a.id.indexOf("play") && (a.getElementsByTagName("video") || a.getElementsByTagName("audio"))) return __opera__preload.log("get videos"),
            !0;
            var b = a.style;
            if (b) {
                if ("undefined" != typeof b.webkitTransition && b.webkitTransition) return this.log("could draggable: " + b.webkitTransition),
                !0;
                if ("undefined" != typeof b.webkitTransform && b.webkitTransform && -1 != b.webkitTransform.indexOf("translate")) {
                    if ( - 1 != this.excludeHostname.indexOf(location.hostname) && -1 != b.webkitTransform.indexOf("translateZ(0")) break;
                    this.log("could draggable: " + b.webkitTransform);
                    return ! 0
                }
            }
            b = a.tagName;
	if (-1 != a.className.indexOf("scroll_wrap") || -1 != a.className.indexOf("scroll-wrap")) return this.log("could draggable: " + a.className + " " + a.className), !0;

            if ("CANVAS" == b || "OBJECT" == b || "VIDEO" == b || "INPUT" == b && "range" == a.type) return this.log("could draggable: " + b + " " + a.type),
            !0;
            if ("undefined" != typeof a.hasAttribute && (a.hasAttribute("ontouchmove") || a.hasAttribute("ontouchstart"))) return this.log("could draggable: has ontouchmove or ontouchstart"),
            !0;
            a = a.parentNode
        }
        return ! 1
    },
    touchStart: function(a) {
        if ("undefined" !== typeof OperaCallback) {
            var b = a.target,
            c = "A" === b.tagName || "INPUT" === b.tagName || "BUTTON" === b.tagName || "VIDEO" === b.tagName || "SELECT" === b.tagName || "OPTION" === b.tagName || "LABEL" === b.tagName || "TEXTAREA" === b.tagName;
            __opera__preload.log("tag in touchStart = " + b.tagName + ", element responsive = " + c);
            OperaCallback.webTouchStart(__opera__preload.isDraggable(a.target) || "" != window.getSelection().toString(), c)
        }
    },
    touchOver: function(a) {
        "undefined" !== typeof OperaCallback && OperaCallback.webTouchOver()
    },
    click: function(a) {
        if ("undefined" !== typeof OperaCallback) {
            var b = a.target;
            if (b.hasAttribute("target")) {
                var c = b.getAttribute("target");
                c && "_blank" == c && OperaCallback.setOpenInNewTab()
            }
            "href" in b && (0 == b.href.indexOf("javascript:history.back()") ? (OperaCallback.historyBack(), a.preventDefault()) : 0 == b.href.indexOf("javascript:history.forward()") ? (OperaCallback.historyForward(), a.preventDefault()) : 0 == b.href.indexOf("javascript:history.go(") && (b = b.href.substring(b.href.indexOf("(") + 1, b.href.indexOf(")")), OperaCallback.historyGo(parseInt(b)), a.preventDefault()))
        }
    },
    hasMediaPalying: function() {
        for (var a = document.getElementsByTagName("audio"), b = 0; b < a.length; ++b) if (!a[b].paused && !a[b].ended) return ! 0;
        a = document.getElementsByTagName("video");
        for (b = 0; b < a.length; ++b) if (!a[b].paused && !a[b].ended) return ! 0;
        return ! 1
    },
    onMediaPlay: function(a) {
        var b = a.target.tagName.toLowerCase();
        if ("video" == b || "audio" == b) __opera__preload.hasPaused ? (__opera__preload.log("__opera__preload.onMediaPlay: pause the media play cause the page has been paused"), a.target.pause()) : "undefined" != typeof OperaCallback && OperaCallback.setHasMediaPlaying && OperaCallback.setHasMediaPlaying(!0)
    },
    onMediaPaused: function(a) {
        a = a.target.tagName.toLowerCase(); ("video" == a || "audio" == a) && "undefined" != typeof OperaCallback && OperaCallback.setHasMediaPlaying && OperaCallback.setHasMediaPlaying(__opera__preload.hasMediaPalying())
    }
};
__opera__preload.init();
window.addEventListener("play", __opera__preload.onMediaPlay, !0);
window.addEventListener("pause", __opera__preload.onMediaPaused, !0);

window.addEventListener("touchstart", __opera__preload.touchStart, !0);
window.addEventListener("touchcancel", __opera__preload.touchOver, !0);
window.addEventListener("touchend", __opera__preload.touchOver, !0);
window.addEventListener("click", __opera__preload.click, !0);
HTMLDivElement.prototype.addEventListener = function(a, b, c) {
    "touchmove" == a && (__opera__preload.log("add intercept " + this.id + " " + this.tagName + " " + this.className), __opera__preload.draggableElements.push(this));
    __opera__preload.realAddEventListener.call(this, a, b, c)
};
HTMLDivElement.prototype.removeEventListener = function(a, b, c) {
    if ("touchmove" == a) {
        var e = __opera__preload.draggableElements.indexOf(this); - 1 < e && (__opera__preload.log("remove intercept " + this.id + " " + this.tagName + " " + this.className), __opera__preload.draggableElements.splice(e, 1))
    }
    __opera__preload.realRemoveEventListener.call(this, a, b, c)
};
}
